if(!isFile("config/server/rules.cs"))
{
	$rules::RuleNumber[$rules::RuleTotal++] = "Do not spam.";
	$rules::RuleNumber[$rules::RuleTotal++] = "Do not cause needless arguments.";
	$rules::RuleNumber[$rules::RuleTotal++] = "Treat other players with respect.";
	$rules::RuleNumber[$rules::RuleTotal++] = "Have fun!";
	export("$rules::rule*", "config/server/rules.cs");
}
else
	exec("config/server/rules.cs");

if($GameModeArg !$= "")
{
	if(isFile(filePath($GameModeArg) @ "/rules.txt"))
	{
		%file = new FileObject(){};

		%file.openForRead(filePath($GameModeArg) @ "/rules.txt");

		while(!%file.isEOF)
		{
			%count++;
			$Rules::RuleNumber[%count] = %file.readLine();
		}

		echo("Gamemode rule file successfully read.");
	}
}

package betterRules
{
	function servercmdmissionstartphase3ack(%client, %bool)
	{
		if($rules::acceptedClients[%client.bl_id])
		{
			cancel(%client.spawnNotificationSoundLoop);
			echo(%client.name SPC "has accepted the rules and was allowed to spawn.");
			%client.isSpawned = 1;
			return parent::servercmdmissionstartphase3ack(%client, %bool);
		}

		else if(%client.readingRule <= 1)
		{
			%client.displayRules();
			%client.schedule(1500, spawnNotificationSound);
		}

		return;
	}

	function servercmdAutoAdminCheck(%client)
	{
		%return = parent::servercmdAutoAdminCheck(%client);

		if(!$rules::acceptedClients[%client.bl_id])
		{
			%client.scheule(50, displayRules);
		}

		return %return;
	}

	function servercmdMessageBoxCancel(%client)
	{
		if(%client.readingRule > 0)
		{
			%client.displayRules(%client.readingRule + 1);
			return;
		}

		return parent::servercmdMessageBoxCancel(%client);
	}

	function servercmdMessageBoxNo(%client)
	{
		if(%client.doesNotAgreeWithTheRules)
		{
			%client.displayRules(%client.readingRule + 1);
			%client.doesNotAgreeWithTheRules = false;
			return;
		}

		if(%client.readingRule >= $rules::RuleTotal && !%client.isSpawned)
		{
			%client.doesNotAgreeWithTheRules = true;
			commandToClient(%client, 'messageBoxYesNo', "Leave server?", "Are you sure you don't agree to the rules?<br>You will be kicked from the server.", 'iDoNotAgreeWithTheRulesPleaseKickMe');
			return;
		}

		return parent::servercmdMessageBoxNo(%client);
	}
};
activatePackage(betterRules);

function gameConnection::displayRules(%this, %number)
{
	if(%number $= "")
		%number = 1;

	if(%number > $rules::RuleTotal && !%this.isSpawned)
	{
		commandToClient(%this, 'messageBoxYesNo', "Agree to rules", "Do you agree to follow all the aforementioned rules?", 'acceptRules');
		return;
	}
	else if(%number > $rules::RuleTotal)
	{
		%this.readingRule = "";
		return;
	}

	%this.readingRule = %number;

	commandToClient(%this, 'messageBoxOKCancel', "Rule" SPC %number, $rules::ruleNumber[%number], 'nextRule');
}

function gameConnection::spawnNotificationSound(%this)
{
	cancel(%this.spawnNotificationSoundLoop);

	if(%this.readingRule > 1)
		return;

	%this.play2D(errorSound);
	%this.spawnNotificationSoundLoop = %this.schedule(1250, spawnNotificationSound);
}

function servercmdNextRule(%client)
{
	if(%client.readingRule > 0)
		%client.displayRules(%client.readingRule + 1);
}

function servercmdAcceptRules(%client)
{
	if($rules::acceptedClients[%client.bl_id] || %client.isSpawned)
		return;

	if(%client.readingRule < $rules::RuleTotal)
	{
		%client.displayRules();
		return;
	}

	$rules::acceptedClients[%client.bl_id] = 1;
	export("$rules::Rule*", "config/server/rules.cs");
	servercmdmissionstartphase3ack(%client, 1);
	%client.readingRule = "";
}

function servercmdiDoNotAgreeWithTheRulesPleaseKickMe(%client)
{
	if(%client.doesNotAgreeWithTheRules)
	{
		%client.delete("You have been kicked because you do not agree with the rules.");
		return;
	}

	%client.doesNotAgreeWithTheRules = true;
	commandToClient(%client, 'messageBoxYesNo', "Leave server?", "Are you sure you don't agree to the rules?<br>You will be kicked from the server.", 'iDoNotAgreeWithTheRulesPleaseKickMe');
}

function servercmdRules(%client)
{
	%client.displayRules();
}

function servercmdSetRule(%client, %number, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12, %word13)
{
	if(!%client.isSuperAdmin)
		return;

	if(%number - 1 < 0)
	{
		%client.chatMessage("Invalid rule number");
		return;
	}

	for(%i = 0; %i < 13; %i++)
		%words = %words SPC %word[%i];

	%words = strReplace(trim(%words), "_", " ");

	if(%words $= "")
	{
		$rules::RuleNumber[%number] = "";

		if($rules::RuleNumber[%number + 1] $= "")
			$rules::RuleTotal = %number - 1;

		%client.chatMessage("Deleted rule" SPC %number);
		return;
	}

	if($rules::RuleNumber[%number - 1] $= "" && %number != 1)
	{
		%client.chatMessage("Can't add this rule because no rule preceeds it. Do /rules to view your current rules.");
		return;
	}

	$rules::RuleNumber[%number] = %words;

	if(%number > $rules::RuleTotal)
		$rules::RuleTotal = %number;

	%client.chatMessage("Remember to use _underscores_ instead of spaces to make longer rules. Do /rules to view how your rules currently look.");
	%client.chatMessage("Rule" SPC %number SPC "has been set to\c6" SPC $rules::RuleNumber[%number]);

	export("$rules::Rule*", "config/server/rules.cs");
}
